VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "TV Timeline"
   ClientHeight    =   3975
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7710
   DrawWidth       =   8
   ForeColor       =   &H00FFFFFF&
   LinkTopic       =   "Form1"
   ScaleHeight     =   3975
   ScaleWidth      =   7710
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command4 
      Caption         =   ">"
      Height          =   255
      Left            =   7440
      TabIndex        =   3
      Top             =   0
      Width           =   255
   End
   Begin VB.CommandButton Command3 
      Caption         =   "<"
      Height          =   255
      Left            =   1800
      TabIndex        =   2
      Top             =   0
      Width           =   255
   End
   Begin VB.CommandButton Command2 
      Caption         =   "Down"
      Height          =   255
      Left            =   0
      TabIndex        =   1
      Top             =   3720
      Width           =   1695
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Up"
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   1695
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Caption         =   "8888"
      Height          =   255
      Left            =   6840
      TabIndex        =   7
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Caption         =   "8888"
      Height          =   255
      Left            =   4320
      TabIndex        =   6
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      Caption         =   "8888"
      Height          =   255
      Left            =   2040
      TabIndex        =   5
      Top             =   0
      Width           =   615
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Label1"
      Height          =   255
      Index           =   0
      Left            =   0
      TabIndex        =   4
      Top             =   360
      Width           =   1695
   End
   Begin VB.Line Line1 
      BorderColor     =   &H00808000&
      X1              =   1800
      X2              =   1800
      Y1              =   3720
      Y2              =   240
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Dim basecnum%
Dim basetslot%
Dim topindex%
Dim tvmap$(255, 576)
'first subscript gives up to 256 channels
'Second subscript:
' 288 - channel name
' 0 > 287 - 24hrs in five minute timeslots
'  0 is 0000 to 0005
'   ...
'  287 is 2355 to 2400
'  hours = Int((timeslot * 5) / 60)
'  minutes = timeslot * 5 - Int((timeslot * 5) / 60) * 60
'  timeslot = hours * 12 + Int(minutes / 5)
'Later addition, comment/url field:
'  289 > 576 - Comments/urls relating to timeslots 0>287
'              timeslot+289=comment
'  Comments starting with URL: will have the 'URL:' heading
'   removed and will be opened.
'  Comments without this heading will be sent to a MSGBOX, this
'   means you can put multiple lines into the comment seperated
'   by a chr$(10) to be displayed as a multi-line message.
Dim areas(73727, 3) As Single 'Definition of screen areas related to programs
Dim areadata$(73727) 'The url/description or whatever
Const maxareas& = 6000
'73727 possible programs
'(its overkill I know, but its the theoretical max
' and you might want to reduce this so I've also implemented
' that CONST which limits how many subscripts the code
' uses when storing/checking/wiping, to increase speed)
'second subscript:
'0 - x1 (left)
'1 - y1 (top)
'2 - x2 (right)
'3 - y2 (bottom)

Sub wipeareas()
For i& = 0 To maxareas&
 areas(i&, 0) = 0
 areas(i&, 1) = 0
 areas(i&, 2) = 0
 areas(i&, 3) = 0
 areadata$(i&) = ""
Next i&
End Sub

Sub definearea(x1 As Single, y1 As Single, x2 As Single, y2 As Single, adata$)
For i& = 0 To maxareas&
 If areas(i&, 0) = 0 And areas(i&, 1) = 0 And areas(i&, 2) = 0 And areas(i&, 3) = 0 And areadata$(i&) = "" Then
  areas(i&, 0) = x1
  areas(i&, 1) = y1
  areas(i&, 2) = x2
  areas(i&, 3) = y2
  areadata$(i&) = adata$
  i& = maxareas&
 End If
Next i&
End Sub

Function clickarea$(xcord As Single, ycord As Single)
rval$ = ""
For i& = 0 To maxareas&
 If xcord >= areas(i&, 0) And xcord <= areas(i&, 2) And ycord >= areas(i&, 1) And ycord <= areas(i&, 3) Then
  rval$ = areadata$(i&)
 End If
Next i&
clickarea$ = rval$
End Function

Sub renderlines()
Dim y As Single, arealastx As Single, myx As Single
wipeareas
'Start by matching display elements to form size:
Command2.Height = Command1.Height
Command2.Width = Command1.Width
Command4.Height = Command3.Height
Command4.Width = Command3.Width
Command1.Top = 0
Command1.Left = 0
Command2.Top = Form1.ScaleHeight - Command2.Height
Command2.Left = 0
Line1.x1 = Command1.Width
Line1.x2 = Command1.Width
Line1.y1 = Command1.Height
Line1.y2 = Command2.Top
Command3.Left = Command1.Width
Command4.Left = Form1.ScaleWidth - Command4.Width
Command3.Top = 0
Command4.Top = 0
Label3.Width = Label2.Width
Label4.Width = Label2.Width
Label2.Top = 0
Label2.Left = Command3.Left + Command3.Width
Label4.Top = 0
Label4.Left = Command4.Left - Label4.Width
Label3.Top = 0
Label3.Left = Label2.Left + Label2.Width + ((Label4.Left - (Label2.Left + Label2.Width)) / 2 - Label3.Width / 2)
'Put correct times into labels at the top
timeslot% = basetslot%
Label2.Caption = Format(Int((timeslot% * 5) / 60), "00") + ":" + Format(timeslot% * 5 - Int((timeslot% * 5) / 60) * 60, "00")
timeslot% = basetslot% + 6
Label3.Caption = Format(Int((timeslot% * 5) / 60), "00") + ":" + Format(timeslot% * 5 - Int((timeslot% * 5) / 60) * 60, "00")
timeslot% = basetslot% + 12
Label4.Caption = Format(Int((timeslot% * 5) / 60), "00") + ":" + Format(timeslot% * 5 - Int((timeslot% * 5) / 60) * 60, "00")
'enable/disable up/down foward/back buttons as required
If basetslot% < 275 Then
 Command4.Enabled = True
Else
 Command4.Enabled = False
End If
If basetslot% > 0 Then
 Command3.Enabled = True
Else
 Command3.Enabled = False
End If
If basecnum% < 255 Then
 Command2.Enabled = True
Else
 Command2.Enabled = False
End If
If basecnum% > 0 Then
 Command1.Enabled = True
Else
 Command1.Enabled = False
End If
'Render channel names and lines with respect to basecnum and basetslot
id% = 0
For y = Line1.y1 + 8 * Screen.TwipsPerPixelY To Line1.y2 Step 16 * Screen.TwipsPerPixelY
 Form1.DrawWidth = 14
 Line (Line1.x1, y)-(Form1.ScaleWidth, y), RGB(0, 64, 192)
 If id% > topindex% Then
  'create a new label
  Load Label1(id%)
  topindex% = id%
 End If
 Label1(id%).Visible = True
 Label1(id%).Left = 0
 Label1(id%).Width = Command1.Width
 Label1(id%).Height = Command2.Height
 Label1(id%).Top = y - 8 * Screen.TwipsPerPixelY - 1
 If id% + basecnum% < 256 Then
  If tvmap$(id% + basecnum%, 288) > "" Then
   Label1(id%).Caption = Format(id% + basecnum%, "0") + ". " + tvmap$(id% + basecnum%, 288) + " "
   'Add breaks to lines when programs change
   l$ = tvmap$(id% + basecnum%, basetslot%)
   Form1.DrawWidth = 2
   arealastx = Line1.x1
   arealastd$ = ""
   For i% = 1 To 12
    If tvmap$(id% + basecnum%, basetslot% + i%) <> l$ Then
     l$ = tvmap$(id% + basecnum%, basetslot% + i%)
     myx = Line1.x1 + (Form1.ScaleWidth - Line1.x1) / 12 * i%
     Line (myx, y + 6 * Screen.TwipsPerPixelY)-(myx, y - 7 * Screen.TwipsPerPixelY), Form1.BackColor
     If arealastd$ > "" Then definearea arealastx, y - 7 * Screen.TwipsPerPixelY, myx, y + 6 * Screen.TwipsPerPixelY, arealastd$
     arealastd$ = tvmap$(id% + basecnum%, basetslot% + i% + 289)
     arealastx = myx
     Form1.Print " " + l$
    End If
   Next i%
   If arealastd$ > "" Then definearea arealastx, y - 7 * Screen.TwipsPerPixelY, Form1.ScaleWidth, y + 6 * Screen.TwipsPerPixelY, arealastd$
  Else
   Label1(id%).Caption = Format(id% + basecnum%, "0") + ". No channel "
  End If
 Else
  Label1(id%).Caption = "No channel "
 End If
 id% = id% + 1
Next y
'Hide redundant labels/lines
highestlabel% = id% - 1
If Label1.Count > highestlabel% + 1 Then
 For i% = highestlabel% + 1 To Label1.Count - 1
  Label1(i%).Visible = False
 Next i%
End If
Line (Command2.Width, Command2.Top)-(Form1.ScaleWidth, Form1.Height), Form1.BackColor, BF
End Sub

Private Sub Command1_Click()
basecnum% = basecnum% - 1
renderlines
End Sub

Private Sub Command2_Click()
basecnum% = basecnum% + 1
renderlines
End Sub

Private Sub Command3_Click()
basetslot% = basetslot% - 1
renderlines
End Sub

Private Sub Command4_Click()
basetslot% = basetslot% + 1
renderlines
End Sub


Private Sub Form_Load()
'Load some dummy data into the tvmap array
tvmap$(0, 288) = "l33t TV"
l% = 0
c% = 1
lc% = 0
For i% = 0 To 287
 tvmap$(0, i%) = "Program " + Format(c%, "0")
 If c% <> lc% Then 'do this when program changes
  'comments/urls only need to be inserted ONCE on the first timeslot
  ' for a program, names do need to be inserted in every timeslot
  ' because the timeline renderer checks for a change in the name
  ' to define when a program has ended and a new one started.
  ' However, if only needs ONE copy of the url/comment.
  If c% / 2 = Int(c% / 2) Then
   'if number is even then add a comment
   tvmap$(0, i% + 289) = "Program " + Format(c%, "0") + Chr$(10) + "This is a test program." + Chr$(10) + "And this comment, is test comment #" + Format(c%, "0")
  Else
   'if number is odd then add a url
   tvmap$(0, i% + 289) = "URL:http://www.bbc.co.uk/"
  End If
  lc% = c%
 End If
 l% = l% + 1
 If l% = 6 Then
  c% = c% + 1
  l% = 0
 End If
Next i%
'Set the base timeslot with respect to the current time
t$ = Format(Time, "HHMM")
basetslot% = Val(Mid$(t$, 1, 2)) * 12 + Int(Val(Mid$(t$, 3, 2)) / 5)
If basetslot% > 275 Then
 basetslot% = 275
End If
'Draw form
renderlines
End Sub



Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, y As Single)
If Button = 1 Then
 a$ = clickarea$(X, y)
 If a$ > "" Then
  If Mid$(a$, 1, 4) = "URL:" Then
   sFile = Mid$(a$, 5)
   lR = ShellExecute(Me.hWnd, "Open", sFile, "", "", vbNormalFocus)
   If (lR < 0) Or (lR > 32) Then
    'success
   Else
    MsgBox "Failed to start '" & sFile & "'", vbInformation
   End If
  Else
   MsgBox a$, , "Program Information"
  End If
 End If
End If
End Sub

Private Sub Form_Paint()
If Form1.WindowState <> 1 Then
 'Do not bother messing around with form if its minimised
 renderlines
End If
End Sub

Private Sub Form_Resize()
If Form1.WindowState <> 1 Then
 'Do not bother messing around with form if its minimised
 renderlines
End If
End Sub

